%% generate the profile
length = 6; %time(s)
dt = 0.01;
q_t = rand([4,1]);%the initial q_t
q_t = q_t/norm(q_t);
data = [];
q_t_omega_set=[];
for  t = 0:dt:length
    %% generate the omega profile
    if t < 3
        omega=[0,0,0];
    else
        omega = [sin(t),0,0];  
    end
    
    %% the true quaternion update
    q_t = left_quaternion_productMatrix(q_t)* QUATexp([0,0.5 * dt * omega])';

    %% simulate the sensor measurements
    cov_noise_i = eye(3)*0.0003;
    cov_a = eye(3)*0.0005;
    cov_mag = eye(3)*0.0003;
    noise_gyro = mvnrnd([0,0,0],sqrt(cov_noise_i));
    omega_obs = omega + noise_gyro;
    q_t_omega = left_quaternion_productMatrix(q_t)* QUATexp([0,0.5 * dt * omega_obs])';
    acc_i = mvnrnd([0,0,0],sqrt(cov_a));
    acc = left_quaternion_productMatrix(quatconj(q_t'))* right_quaternion_productMatrix(q_t)* [0. 0, 0, 1]';
    acc_m = acc(2:4)' + acc_i;
    acc_m = acc_m/norm(acc_m);
    mag_i = mvnrnd([0,0,0],sqrt(cov_mag));
    mag = left_quaternion_productMatrix(quatconj(q_t'))* right_quaternion_productMatrix(q_t)* [0,cos(30/180*pi),0,sin(30/180*pi)]';
    mag_m = mag(2:4)' + mag_i;
    mag_m = mag_m/norm(mag_m);
     
    a = [q_t',omega_obs,acc_m,mag_m];
    data = [data;a];
    q_t_omega_set = [q_t_omega_set;q_t_omega'];
end

%% save as csv
csvwrite( 'profile.csv',data);

%% plot
figure
plot(data(:,1:4))
hold on 
plot(q_t_omega_set)
% figure
% plot(data(:,8:10))
% figure
% plot(data(:,11:13))